#<profile4xi profile = "31"/>
#<program4xi program = "fetch2scope4xi.py">
#<abstract4xi abstract = "fetches defined programs from scope4xi folders"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "output is automatically deleted and written again by opening to write"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#       > go3studio4fb <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#       Tip: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 2) > fetch2scope4xi
#      
#
# 3) view results
#    fetch2scope4xi.txt
#    programs in folder temp2scope4py defined by version4xi.py
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fetch2scope4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global count2skipped
global count2found
global count2total
global kb2fetch                              # knowledgebase for fetching
global path2temp4source  
global path2read4xi                          # path for input source programs
global path2write4xi                         # path for output source programs
global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
count2skipped = 0
count2found = 0
count2total = 0                                                                                            
kb2fetch = {}                                # programs to be fetched                                
                                             # kb2fetch[1] = 'apu2image4xi.py'
                                             # kb2fetch[2] = 'apu2image4xi5test.py'
                                             # kb2fetch[3] = 'apu3image4xi.py'
                                             # kb2fetch[4] = 'apu3image4xi5test.py'
kb2fetch[1] = 'apu2program4xi.py'
kb2fetch[2] = 'apu2program4xi5test.py'

path2read4xi  = VersionKB4Xi['py2lib4scope'] # defines folder to be walked with all its subfolders
path2write4xi = VersionKB4Xi['temp2scope4py']# defines folder to save programs

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.py'                        # Python programs to be fetched
                                             # Extensions: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 1A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 1B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 1A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 1B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 2A/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 2B/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 2C/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 2D/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 2Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 2E/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 2F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 1A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Pipe4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',         
         'Process4Xi': 'NACK4TRACE',
         'fetch2scope4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 2A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi, Process4Xi, Queue4Xi, fetch2scope4xi

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 33/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #04:16:46 10/17/11 Pacific Daylight Time 

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "fetch2scope4xi"
    method2print = "fetch2scope4xi" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-fetch2scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing fetch2scope4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">fetch2scope4xi sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-fetch2scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for fetch2scope4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-fetch2scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for fetch2scope4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of fetch2scope4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2scope4xi" usage = "
#   fetches defined programs from scope4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2scope4xi(program2explore):
    global count2skipped
    global count2found
    global count2total
    global kb2fetch                              # knowledgebase for fetching    
    global path2read4xi                          # path for input source programs
    global path2write4xi                         # path for output source programs
    global profile2fetch                         # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "fetch2scope4xi"
    method2print = "fetch2scope4xi" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-fetch2scope4xi: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    message2print = "{(Step 1/8) got" + "; program2explore-got-by-fetch2scope4xi: " + str(program2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # ..//..//..//..//scope4xi//041721//zap//lib//_\version4xi.py  <-- same format as used by Pipe4Xi which has ok trace for reason and ace XML!
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program=os.path.splitext(program2explore)
    
    if name2program[1] == profile2fetch:          
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - PYTHON PROGRAM
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore-analyzing-by-fetch2scope4xi: " + str(program2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # ..//..//..//..//scope4xi//041721//zap//lib//_\version4xi.py
        
        
        path2input = name2program[0] + profile2fetch 
        message2print = "{(Step 1B/33) set" + "; path2input-set-by-fetch2scope4xi to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # L://temp//py//apu2image4xi.py
        
        # 
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) analyzing" + "; path2input-analyzing-by-fetch2scope4xi: " + str(path2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        keys2fetch = kb2fetch.keys()
        ack2match = False
        for key2fecth in keys2fetch:                                                                                # 1,2,3,4
            string2search = kb2fetch[key2fecth]                                                                     # apu2image4xi.py ...
            index2search=str.find(path2input,string2search)                                                         # ..//..//..//..//scope4xi//041721//zap//lib//a\apu2image4xi.py
            if index2search == -1:                                         
                pass                                                                                                # not ordered to be fetched
            else:
                path2write4program = path2write4xi + path2input[index2search:]                                      # ..//..//..//..//studio4xi//python//3.2//src//apu2image4xi.py     
                ack2match = True
                    
        if ack2match is True:
            message2print = "{(Step 2B/33) decided" + "; program-to-read-decided-by-fetch2scope4xi: " + str(path2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
            # L://temp//py//apu2image4xi.py

            message2print = "{(Step 2C/33) decided" + "; program-to-write-decided-by-fetch2scope4xi: " + str(path2write4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            # L://temp//py//apu2image4xi.py

                          
            count2found = count2found + 1
            count2total = count2total + 1
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT
            # -----------------------------------------------------------------------------------------
            file2input = open(path2input,'r')
            message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-fetch2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # <_io.TextIOWrapper name='..//..//..//..//scope4xi//041721//zap//lib//a\\apu2image4xi.py' mode='r' encoding='cp1252'>

            
            # -----------------------------------------------------------------------------------------
            # (Step 4/33) OF FETCH2SCOPE4XI - OPEN OUTPUT
            # -----------------------------------------------------------------------------------------
            file2output = open(path2write4program,'w')
            message2print = "{(Step 3B/33) opened" + "; file2output-opened-by-fetch2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)              
            # <_io.TextIOWrapper name='L://temp//py//apu2image4xi.py' mode='w' encoding='cp1252'>

            while 1:
                # -------------------------------------------------------------------------------------
                # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                # -------------------------------------------------------------------------------------             
                line2process = file2input.readline()  
                if not line2process:
                    # ---------------------------------------------------------------------------------
                    # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                    # ---------------------------------------------------------------------------------             
                    break                                               
                else:
                    # ---------------------------------------------------------------------------------
                    # (Step 7/33) OF FETCH2SCOPE4XI - PROCESS LINE
                    # ---------------------------------------------------------------------------------
                    
                    
                    
                    line2write = line2process     
                    # ---------------------------------------------------------------------------------
                    # (Step 29/33) OF FETCH2SCOPE4XI - WRITE PROCESSED LINE
                    # ---------------------------------------------------------------------------------                           
                    
                    file2output.write(line2write)
        
            
            # -----------------------------------------------------------------------------------------
            # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
            # -----------------------------------------------------------------------------------------            
            file2input.close()
            message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-fetch2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           

            # <_io.TextIOWrapper name='..//..//..//..//scope4xi//041721//zap//lib//a\\apu2image4xi.py' mode='r' encoding='cp1252'>
            # <_io.TextIOWrapper name='..//..//..//..//scope4xi//041721//zap//lib//a\\apu2image4xi5test.py' mode='r' encoding='cp1252'>
            # <_io.TextIOWrapper name='..//..//..//..//scope4xi//041721//zap//lib//a\\apu3image4xi.py' mode='r' encoding='cp1252'>
            # <_io.TextIOWrapper name='..//..//..//..//scope4xi//041721//zap//lib//a\\apu3image4xi5test.py' mode='r' encoding='cp1252'> 
            
                        
            # -----------------------------------------------------------------------------------------
            # (Step 32/33) OF FETCH2SCOPE4XI - CLOSE OUTPUT
            # -----------------------------------------------------------------------------------------            
            file2output.close()
            message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-fetch2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <_io.TextIOWrapper name='L://temp//py//apu2image4xi.py' mode='w' encoding='cp1252'>
            # <_io.TextIOWrapper name='L://temp//py//apu2image4xi5test.py' mode='w' encoding='cp1252'>
            # <_io.TextIOWrapper name='L://temp//py//apu3image4xi.py' mode='w' encoding='cp1252'>
            # <_io.TextIOWrapper name='L://temp//py//apu3image4xi5test.py' mode='w' encoding='cp1252'>
            
        else:
            message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-fetch2scope4xi: " + str(path2input)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # ..//..//..//..//scope4xi//041721//zap//lib//a\version4xi.py
            count2skipped = count2skipped + 1
            count2total = count2total + 1

    else:
        message2print = "{(Step 1F/33) skipped" + "; name2program-skipped-by-fetch2scope4xi: " + str(name2program)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # ('..//..//..//..//scope4xi//041721//zap//lib//a\\__pycache__\\apu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2scope4xi: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global count2skipped
    global count2found
    global count2total
    
    global path2read4xi
    global path2write4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1A/33) OF MAIN FETCH2SCOPE4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2found = 0
    count2total  = 0   

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 2A/33) OF MAIN FETCH2SCOPE4XI - VERSION 8.12 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # ..//..//..//..//scope4xi//041721//zap//lib//
    
    path2temp4source = VersionKB4Xi['temp2scope4py']
    print ('(Step 2B/33) OF MAIN FETCH2SCOPE4XI - PATH WHERE SOURCE PROGRAMS ARE BEING TEMPORARY PROCESSED: ', path2write4xi)
    # L://temp//py//
    print('=' *70)    
   
    pipe2fetch = Pipe4Xi()
    print("(Step 2C/33) OF MAIN FETCH2SCOPE4XI - PIPE2FETCH ", pipe2fetch)    
    
    queue2fetch = Queue4Xi()
    print("(Step 2D/33) OF MAIN FETCH2SCOPE4XI - QUEUE2FETCH ", queue2fetch)    
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print ("Directory: " + file2walk + '\n')
        if os.path.isfile(file2walk):
            #print "Input file: " + file2walk + '\n'
            fetch2scope4xi(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN FETCH2SCOPE4XI - VERSION 8.12 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
            
    # -------------------------------------------------------------------------------------------
    # STATISTICS
    # ------------------------------------------------------------------------------------------- 
    print ('(Step 4A/33) OF MAIN FETCH2SCOPE4XI - FOUND: ', count2found)
    print ('(Step 4B/33) OF MAIN FETCH2SCOPE4XI - SKIPPED: ', count2skipped)
    print ('(Step 4C/33) OF MAIN FETCH2SCOPE4XI - TOTAL: ', count2total)
    test2total = count2found + count2skipped
    if test2total == count2total:
        pass
    else:
        print ('(Step 4Z/33) OF MAIN FETCH2SCOPE4XI *** FAILED: FOUND + SKIPPED: ', test2total, " .NE. TOTAL: ", count2total, " ***")
        
    # ===========================================================================
    # FETCH2SCOPE4XI VERSION 8.12 FOR  ..//..//..//..//scope4xi//041721//zap//lib//  WITH PROFILE:  .py  COMPLETED   22:31:56 10/12/11 Pacific Daylight Time
    # FOUND:  4
    # SKIPPED:  407
    # TOTAL:  411
    # ===========================================================================         
    print('=' *75)
    
    
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(Step 33A/33) OF MAIN FETCH2SCOPE4XI - PRINTING TRACE WITH T2XI', t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    print_trace4xi(t2xi)        
    print ('(Step 33B/33) OF MAIN FETCH2SCOPE4XI - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# L://temp//py//
# L:\temp\txt\fetch2scope4xi.txt
# ROOT4XI\Studio4Xi\web\xml\ace-fetch2scope.xml
# ROOT4XI\Studio4Xi\web\xml\reason-fetch2scope.xml
# ROOT4XI\Studio4Xi\web\xml\sense-fetch2scope.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fetch2scope4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

